/*
 * Wuerfel_2.asm
 *
 *  Created: 09.08.2018 11:55:18
 *   Author: Miroslav Cina
 *
 *  Inclusive Demo - a switch is connected to PC5 (Pin28); if is put to GND a demo is running
 */

start:
; ---------------------------------------------------------------
; Initialization
; ---------------------------------------------------------------
;(1-1)
;7-Segment LED - connected to RD0-7
	ldi		r16,0xFF
	out		DDRD,r16			;all PD I/O to output
;(1-2)
;dice LEDs
	ldi		r16,(1<<DDB0)|(1<<DDB1)|(1<<DDB2)|(1<<DDB3)
	out		DDRB,r16
;(1-3)
;button shall be input
	cbi		DDRC,0x00			;PC0 as input
	cbi		DDRC,0x05			;PC5 as input
;(1-4)
;enable Pull-ups
	sbi		PORTC,0x00			;enable pull-up for PC0
	sbi		PORTC,0x05			;enable pull-up for PC5
;(1-5)
	ldi		r16,0
	ldi		r17,7
; ------------------------------------------------------------------
; ------------------------------------------------------------------
; Main Loop - Business Logic
; ------------------------------------------------------------------
; ------------------------------------------------------------------
main_loop:
	rcall	disp_all			;(2-1)
	rcall	delay1				;(2-2) wait a while
	sbis	PINC,0x05			;demo required?
	rjmp	main_loop_demo
	sbic	PINC,0x00			;(2-3) jump over, if button is pressed
	rjmp	main_loop			;(2-4)
	inc		r16					;(2-5) add 1 to the result value
	cp		r16, r17			;(2-6) overflow?
	brne	main_loop			;(2-7) no, start again the main loop
	ldi		r16,1				;(2-8) start over
	rjmp	main_loop			;(2-9)
; -----------------------------------------------------------------
; -----------------------------------------------------------------
; End of Main Loop
; -----------------------------------------------------------------
; -----------------------------------------------------------------
main_loop_demo:
	rcall	disp_all			;(2-1)
	rcall	delay2				;(2-2) wait a while
	sbic	PINC,0x05			;demo required?
	rjmp	main_loop			;back to main loop
	inc		r16					;(2-5) add 1 to the result value
	cp		r16, r17			;(2-6) overflow?
	brne	main_loop_demo		;(2-7) no, start again the main loop
	ldi		r16,1				;(2-8) start over
	rjmp	main_loop_demo

; -----------------------------------------------------------------
; -----------------------------------------------------------------
delay1:
	ldi		R19,020
d_loop2:
	ldi		R18,255
d_loop1:
	dec		R18
	brne	d_loop1
	dec		r19
	brne	d_loop2
	ret
; -----------------------------------------------------------------
; -----------------------------------------------------------------
delay2:
	ldi		R19,255
d_loop22:
	ldi		R18,255
d_loop21:
	dec		R18
	brne	d_loop21
	dec		r19
	brne	d_loop22
	ret
; -----------------------------------------------------------------
; -----------------------------------------------------------------
disp_all:
	rcall	disp1
	rcall	disp2
	ret
; -----------------------------------------------------------------
; -----------------------------------------------------------------
; 7-Segment LED
; -----------------------------------------------------------------
; -----------------------------------------------------------------
disp1:
	cpi		r16,1
	breq	w1_1		;display 1

	cpi		r16,2
	breq	w1_2		;display 2

	cpi		r16,3
	breq	w1_3		;display 3
	
	cpi		r16,4
	breq	w1_4		;display 4

	cpi		r16,5
	breq	w1_5		;display 5

	cpi		r16,6
	breq	w1_6		;display 6

	rjmp	w1_0		;display not used combination
;----------------------------------------------------------------
w1_1:
	ldi		r20,0b00000110
	out		PORTD,r20
	ret
;-----------------------
w1_2:
	ldi		r20,0b01011011
	out		PORTD,r20
	ret
;-----------------------
w1_3:
	ldi		r20,0b01001111
	out		PORTD,r20
	ret
;-----------------------
w1_4:
	ldi		r20,0b01100110
	out		PORTD,r20
	ret
;-----------------------
w1_5:
	ldi		r20,0b01101101
	out		PORTD,r20
	ret
;-----------------------
w1_6:
	ldi		r20,0b01111101
	out		PORTD,r20
	ret
;-----------------------
w1_0:
	ldi		r20,0b01000000
	out		PORTD,r20
	ret
;-----------------------
; -----------------------------------------------------------------
; -----------------------------------------------------------------
; Cube LEDs
; -----------------------------------------------------------------
; -----------------------------------------------------------------
disp2:
	cpi		r16,1
	breq	w2_1		;display 1

	cpi		r16,2
	breq	w2_2		;display 2

	cpi		r16,3
	breq	w2_3		;display 3
	
	cpi		r16,4
	breq	w2_4		;display 4

	cpi		r16,5
	breq	w2_5		;display 5

	cpi		r16,6
	breq	w2_6		;display 6

	rjmp	w2_0		;display not used combination
;----------------------------------------------------------------
w2_1:
	ldi		r20,0b00000010
	out		PORTB,r20
	ret
;-----------------------
w2_2:
	ldi		r20,0b00000001
	out		PORTB,r20
	ret
;-----------------------
w2_3:
	ldi		r20,0b00000011
	out		PORTB,r20
	ret
;-----------------------
w2_4:
	ldi		r20,0b00001001
	out		PORTB,r20
	ret
;-----------------------
w2_5:
	ldi		r20,0b00001011
	out		PORTB,r20
	ret
;-----------------------
w2_6:
	ldi		r20,0b00001101
	out		PORTB,r20
	ret
;-----------------------
w2_0:
	ldi		r20,0b00000100
	out		PORTB,r20
	ret
;----------------------------------------------------------------